/**
 * Copyright (C) 2020-2022 Dušan Vejnović <vaadin@dussan.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.dussan.vaadin.dvirtual.database.data;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity( name = "ApplicationsGroupApplicationData" )
@Table( name = "dv_applications_group_application" )
public class ApplicationsGroupApplicationData
    implements Serializable
{

    private static final long serialVersionUID = -6364663121142468435L;

    @Id
    @Column( name = "applications_group_id", nullable = false )
    private Long applicationsGroupId;

    @Id
    @Column( name = "application_id", nullable = false )
    private Long applicationId;

    public ApplicationsGroupApplicationData()
    {
        // nothing to do
    }

    public ApplicationsGroupApplicationData( long applicationId, long applicationsGroupId )
    {
        setApplicationId( applicationId );
        setApplicationsGroupId( applicationsGroupId );
    }

    public Long getApplicationsGroupId()
    {
        return applicationsGroupId;
    }

    public void setApplicationsGroupId( Long applicationsGroupId )
    {
        this.applicationsGroupId = applicationsGroupId;
    }

    public Long getApplicationId()
    {
        return applicationId;
    }

    public void setApplicationId( Long applicationId )
    {
        this.applicationId = applicationId;
    }

    @Override
    public int hashCode()
    {
        final int prime = 31;
        int result = 1;
        result = prime * result + ( ( applicationId == null ) ? 0 : applicationId.hashCode() );
        result = prime * result + ( ( applicationsGroupId == null ) ? 0 : applicationsGroupId.hashCode() );
        return result;
    }

    @Override
    public boolean equals( Object obj )
    {
        if ( this == obj )
        {
            return true;
        }
        if ( obj == null )
        {
            return false;
        }
        if ( !( obj instanceof ApplicationsGroupApplicationData ) )
        {
            return false;
        }
        ApplicationsGroupApplicationData other = (ApplicationsGroupApplicationData) obj;
        if ( applicationId == null )
        {
            if ( other.applicationId != null )
            {
                return false;
            }
        }
        else if ( !applicationId.equals( other.applicationId ) )
        {
            return false;
        }
        if ( applicationsGroupId == null )
        {
            if ( other.applicationsGroupId != null )
            {
                return false;
            }
        }
        else if ( !applicationsGroupId.equals( other.applicationsGroupId ) )
        {
            return false;
        }
        return true;
    }

}
