/**
 * Copyright (C) 2020-2022 Dušan Vejnović <vaadin@dussan.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.dussan.vaadin.dvirtual.icons;

import com.vaadin.flow.component.icon.Icon;

public enum IconicIcon
{

    CHAT( "chat" ),
    CHAT_ALT_STROKE( "chat-alt-stroke" ),
    CHAT_ALT_FILL( "chat-alt-fill" ),
    COMMENT_ALT1_STROKE( "comment-alt1-stroke" ),
    COMMENT( "comment" ),
    COMMENT_STROKE( "comment-stroke" ),
    COMMENT_FILL( "comment-fill" ),
    COMMENT_ALT2_STROKE( "comment-alt2-stroke" ),
    COMMENT_ALT2_FILL( "comment-alt2-fill" ),
    CHECKMARK( "checkmark" ),
    CHECK_ALT( "check-alt" ),
    X( "x" ),
    X_ALTX_ALT( "x-altx-alt" ),
    DENIED( "denied" ),
    CURSOR( "cursor" ),
    RSS( "rss" ),
    RSS_ALT( "rss-alt" ),
    WRENCH( "wrench" ),
    DIAL( "dial" ),
    COG( "cog" ),
    CALENDAR( "calendar" ),
    CALENDAR_ALT_STROKE( "calendar-alt-stroke" ),
    CALENDAR_ALT_FILL( "calendar-alt-fill" ),
    SHARE( "share" ),
    MAIL( "mail" ),
    HEART_STROKE( "heart-stroke" ),
    HEART_FILL( "heart-fill" ),
    MOVIE( "movie" ),
    DOCUMENT_ALT_STROKE( "document-alt-stroke" ),
    DOCUMENT_ALT_FILL( "document-alt-fill" ),
    DOCUMENT_STROKE( "document-stroke" ),
    DOCUMENT_FILL( "document-fill" ),
    PLUS( "plus" ),
    PLUS_ALT( "plus-alt" ),
    MINUS( "minus" ),
    MINUS_ALT( "minus-alt" ),
    PIN( "pin" ),
    LINK( "link" ),
    BOLT( "bolt" ),
    MOVE( "move" ),
    MOVE_ALT1( "move-alt1" ),
    MOVE_ALT2( "move-alt2" ),
    EQUALIZER( "equalizer" ),
    AWARD_FILL( "award-fill" ),
    AWARD_STROKE( "award-stroke" ),
    MAGNIFYING_GLASS( "magnifying-glass" ),
    TRASH_STROKE( "trash-stroke" ),
    TRASH_FILL( "trash-fill" ),
    BEAKER_ALT( "beaker-alt" ),
    BEAKER( "beaker" ),
    KEY_STROKE( "key-stroke" ),
    KEY_FILL( "key-fill" ),
    NEW_WINDOW( "new-window" ),
    LIGHTBULB( "lightbulb" ),
    SPIN_ALT( "spin-alt" ),
    SPIN( "spin" ),
    CURVED_ARROW( "curved-arrow" ),
    UNDO( "undo" ),
    RELOAD( "reload" ),
    RELOAD_ALT( "reload-alt" ),
    LOOP( "loop" ),
    LOOP_ALT1( "loop-alt1" ),
    LOOP_ALT2( "loop-alt2" ),
    LOOP_ALT3( "loop-alt3" ),
    LOOP_ALT4( "loop-alt4" ),
    TRANSFER( "transfer" ),
    MOVE_VERTICAL( "move-vertical" ),
    MOVE_VERTICAL_ALT1( "move-vertical-alt1" ),
    MOVE_VERTICAL_ALT2( "move-vertical-alt2" ),
    MOVE_HORIZONTAL( "move-horizontal" ),
    MOVE_HORIZONTAL_ALT1( "move-horizontal-alt1" ),
    MOVE_HORIZONTAL_ALT2( "move-horizontal-alt2" ),
    ARROW_LEFT( "arrow-left" ),
    ARROW_LEFT_ALT1( "arrow-left-alt1" ),
    ARROW_LEFT_ALT2( "arrow-left-alt2" ),
    ARROW_RIGHT( "arrow-right" ),
    ARROW_RIGHT_ALT1( "arrow-right-alt1" ),
    ARROW_RIGHT_ALT2( "arrow-right-alt2" ),
    ARROW_UP( "arrow-up" ),
    ARROW_UP_ALT1( "arrow-up-alt1" ),
    ARROW_UP_ALT2( "arrow-up-alt2" ),
    ARROW_DOWN( "arrow-down" ),
    ARROW_DOWN_ALT1( "arrow-down-alt1" ),
    ARROW_DOWN_ALT2( "arrow-down-alt2" ),
    CD( "cd" ),
    STEERING_WHEEL( "steering-wheel" ),
    MICROPHONE( "microphone" ),
    HEADPHONES( "headphones" ),
    VOLUME( "volume" ),
    VOLUME_MUTE( "volume-mute" ),
    PLAY( "play" ),
    PAUSE( "pause" ),
    STOP( "stop" ),
    EJECT( "eject" ),
    FIRST( "first" ),
    LAST( "last" ),
    PLAY_ALT( "play-alt" ),
    FULLSCREEN_EXIT( "fullscreen-exit" ),
    FULLSCREEN_EXIT_ALT( "fullscreen-exit-alt" ),
    FULLSCREEN( "fullscreen" ),
    FULLSCREEN_ALT( "fullscreen-alt" ),
    IPHONE( "iphone" ),
    BATTERY_EMPTY( "battery-empty" ),
    BATTERY_HALF( "battery-half" ),
    BATTERY_FULL( "battery-full" ),
    BATTERY_CHARGING( "battery-charging" ),
    COMPASS( "compass" ),
    BOX( "box" ),
    FOLDER_STROKE( "folder-stroke" ),
    FOLDER_FILL( "folder-fill" ),
    AT( "at" ),
    AMPERSAND( "ampersand" ),
    INFO( "info" ),
    QUESTION_MARK( "question-mark" ),
    PILCROW( "pilcrow" ),
    HASH( "hash" ),
    LEFT_QUOTE( "left-quote" ),
    RIGHT_QUOTE( "right-quote" ),
    LEFT_QUOTE_ALT( "left-quote-alt" ),
    RIGHT_QUOTE_ALT( "right-quote-alt" ),
    ARTICLE( "article" ),
    READ_MORE( "read-more" ),
    LIST( "list" ),
    LIST_NESTED( "list-nested" ),
    BOOK( "book" ),
    BOOK_ALT( "book-alt" ),
    BOOK_ALT2( "book-alt2" ),
    PEN( "pen" ),
    PEN_ALT_STROKE( "pen-alt-stroke" ),
    PEN_ALT_FILL( "pen-alt-fill" ),
    PEN_ALT2( "pen-alt2" ),
    BRUSH( "brush" ),
    BRUSH_ALT( "brush-alt" ),
    EYEDROPPER( "eyedropper" ),
    LAYERS_ALT( "layers-alt" ),
    LAYERS( "layers" ),
    IMAGE( "image" ),
    CAMERA( "camera" ),
    APERTURE( "aperture" ),
    APERTURE_ALT( "aperture-alt" ),
    CHART( "chart" ),
    CHART_ALT( "chart-alt" ),
    BARS( "bars" ),
    BARS_ALT( "bars-alt" ),
    EYE( "eye" ),
    USER( "user" ),
    HOME( "home" ),
    CLOCK( "clock" ),
    LOCK_STROKE( "lock-stroke" ),
    LOCK_FILL( "lock-fill" ),
    UNLOCK_STROKE( "unlock-stroke" ),
    UNLOCK_FILL( "unlock-fill" ),
    TAG_STROKE( "tag-stroke" ),
    TAG_FILL( "tag-fill" ),
    SUN_STROKE( "sun-stroke" ),
    SUN_FILL( "sun-fill" ),
    MOON_STROKE( "moon-stroke" ),
    MOON_FILL( "moon-fill" ),
    CLOUD( "cloud" ),
    RAIN( "rain" ),
    UMBRELLA( "umbrella" ),
    STAR( "star" ),
    MAP_PIN_STROKE( "map-pin-stroke" ),
    MAP_PIN_FILL( "map-pin-fill" ),
    MAP_PIN_ALT( "map-pin-alt" ),
    TARGET( "target" ),
    DOWNLOAD( "download" ),
    UPLOAD( "upload" ),
    CLOUD_DOWNLOAD( "cloud-download" ),
    CLOUD_UPLOAD( "cloud-upload" ),
    FORK( "fork" ),
    PAPERCLIP( "paperclip" );

    private static final String ICON_NAME = "%s:%s";

    private static final String ICON_NAME_SEPARATOR = ":";

    public static final String ICON_COLLECTION_NAME = "iconic";

    public static final String ICON_DESCRIPTION = "Iconic";

    private String name;

    IconicIcon( String name )
    {
        this.name = name;
    }

    @SuppressWarnings( "deprecation" )
    public Icon create()
    {
        return new Icon( ICON_COLLECTION_NAME, name );
    }

    public String getIconName()
    {
        return String.format( ICON_NAME, ICON_COLLECTION_NAME, name );
    }

    public String getIconCollectionName( String iconName )
    {
        return iconName.split( ICON_NAME_SEPARATOR )[0];
    }


}
