/**
 * Copyright (C) 2020-2022 Dušan Vejnović <vaadin@dussan.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.dussan.vaadin.dvirtual.xpra.window;

import java.io.Serializable;

public class Cursor
    implements Serializable
{

    private static final long serialVersionUID = 5582628338223276729L;

    private int x = 0;

    private int y = 0;

    private String image = null;

    private String pictureEncodingType = null;

    public Cursor( int x, int y, String image, String pictureEncodingType )
    {
        this.x = x;
        this.y = y;
        this.image = image;
        this.pictureEncodingType = pictureEncodingType;
    }

    public int getX()
    {
        return x;
    }

    public int getY()
    {
        return y;
    }

    public String getImage()
    {
        return image;
    }

    public String getPictureEncodingType()
    {
        return pictureEncodingType;
    }

}
